% Program example_11_1
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Cascade of CIC filter and FIR filter which compensates CIC filter passband response
clear all, close all
N = 5; K = 4; % Setting the design parameters for G_K(z)
A = ([1,zeros(size(1:N-1)),-1]/N); B = [1,-1]; % CIC filter section G(z) = A(z)/B(z)
[G,f] = freqz(A,B,1024,2); % Computing the CIC filter frequency response
GK = G.^K; % Computing the frequency response of G(z)^K 
figure (1)
plot(f,20*log10(abs(GK)),'k','LineWidth',2)
hold on
xlabel('\omega/\pi'),ylabel('Gain, dB')
axis([0,1,-100,2])
Nord=26; % Filter order for T(z)
Fo = [0,0.3,0.505,1]; Ao = [0.981,1.11,0,0]; %Setting the specifications for T(z)
t = firpm(Nord,Fo,Ao); % Computing the coefficients of T(z)
[T,f]=freqz(t,1,1024,2); % Computing the frequency response of T(z)
figure (1)
tN=upsample(t,N); % Computing the coefficients of T(z^N)
[TN,f]=freqz(tN,1,1024,2); %  Computing the frequency response of T(z^N)
plot(f,20*log10(abs(TN)),'--k',f,20*log10(abs(GK)),'-k','LineWidth',2)
grid
axis([0,1,-100,2])
H = TN.*GK; % Computing the frequency response of (G(z)^K)*T(z^N)
figure (2)
plot(f,20*log10(abs(H)),'k','LineWidth',2)
xlabel('\omega/\pi'),ylabel('Gain, dB')
grid
axis([0,1,-100,2])
g(1)=axes('Position',[0.35 0.71 0.45 0.1]);
plot(f(1:54),20*log10(abs(H(1:54))),'k','LineWidth',2), axis([0,0.051,-0.2,0.2]),grid
