% Program example_11_4
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Modified sharpened FIR filter
clear all, close all
K = 2; N = 32; N1 = 8; N2 = 4; L = 5; % Setting the design parameters
f = 0:0.001:1;  % Setting the frequency axis
omega = pi*f;  % Angular frequencies
H1 = (sin(omega*N/2)./sin(omega*N1/2))/N2; % Amplitude response of the CIC filter H1(z)
H2 = (sin(omega*N1/2)./sin(omega/2))/N1; % Amplitude response of the CIC filter H2(z)
H_sh_m = abs((3*H1.^(2*K) - 2*H1.^(3*K)).*(H2.^L)); % Magnitude response of the the modified sharpened filter
figure (1)
plot(f,20*log10(H_sh_m),'k','LineWidth',2)
axis([0,1,-250,5]), grid
hold on
G = (sin(omega*N/2)./sin(omega/2))/N; % Amplitude response of the original CIC filter 
GK = G.^K; % Computing the amplitude response of G(z).^K 
plot(f,20*log10(abs(GK)),'k','LineWidth',1)
H_sh = abs(3*G.^(2*K) - 2*G.^(3*K)); % Magnitude response of the original sharpened CIC filter
plot(f,20*log10(H_sh),'--k','LineWidth',2), xlabel('\omega/\pi'), ylabel('Gain, dB')
figure (2)
subplot(2,1,1)
plot(f(1:21),20*log10(H_sh_m(1:21)),'k','LineWidth',2)
hold on
plot(f(1:21),20*log10(H_sh(1:21)),'--k','LineWidth',2), xlabel('\omega/\pi'), ylabel('Gain, dB')
hold on
plot(f(1:21),20*log10(abs(GK(1:21))),'k','LineWidth',1)
axis([0,0.02,-4,0.2]), grid
plot(f,20*log10(abs(GK)),'k','LineWidth',1)