% Example_11_5
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
clear all, close all
N=16;                                                   % Decimation factor
f = 0:0.00005:1;                                        % Frequency scale
fm = 0.02;                                              % Maximum signal frequency 
q = 0.78                                                % factor q
G=sin(pi*f*N/2)./(N*sin(pi*f/2));                       % Comb filter frequency response
alpha = 0.78*pi*fm;                                     % Rotating angle alpha                                        
Gq = (sin((pi*f+alpha)*N/2)./sin((pi*f+alpha)/2));    
Gq = Gq.*(sin((pi*f-alpha)*N/2)./sin((pi*f-alpha)/2));
Gq = Gq/(N^2);                                          % RS filter section
GMC3 = Gq.*G;                                           % Modified comb filter section
figure (1)
plot(f,60*log10(abs(G)),'k--','LineWidth',2), xlabel('\omega/\pi'),ylabel('Gain, dB')
hold on
figure (1)
%subplot(3,1,1:2)
plot(f,20*log10(abs(GMC3)),'k','LineWidth',2), xlabel('\omega/\pi'),ylabel('Gain, dB')
plot([f(400),f(2100),f(2900)],20*log10([abs(GMC3(400)),abs(GMC3(2100)),abs(GMC3(2900))]),'ok')
plot([f(2100),f(2900)],60*log10([abs(G(2100)),abs(G(2900))]),'ok')
axis([0,0.32,-100,2])
g(1)=axes('Position',[0.60 0.71 0.2 0.1]);
plot(f(1:410),20*log10(abs(GMC3(1:410))),'k',f(1:410),60*log10(abs(G(1:410))),'k--','LineWidth',2), axis([0,0.02,-2,0.1]),grid
A = [1,-2*cos(alpha*N),1];
B = conv([1,-2*cos(alpha),1],[1,-1]);
A = conv(upsample(A,N),upsample([1,-1],N));
figure (2)
zplane(A,1)
figure (3)
ACu = upsample([1,-1],16);
AC = conv(ACu,ACu);
AC = conv(AC,ACu);
zplane(AC,1)
H11 = (G.^2).*Gq;
H11 = H11.*(3*ones(size(f))-2*(G.^2));
figure (4)

plot(f,20*log10(abs(H11)),'k','LineWidth',1)
xlabel('\omega/\pi'),ylabel('Gain, dB')
axis([0,1,-200,2])
g(2)=axes('Position',[0.40 0.75 0.4 0.1]);
plot(f(1:410),20*log10(abs(H11(1:410))),'k','LineWidth',1), axis([0,0.02,-0.65,-0.40])
%figure (5)
%plot(f,20*log10(abs(Gq)),'k','LineWidth',1)
%axis([0,1,-200,2])